/*
 * _gen/svc-Channel.c - Source for TpSvcChannel
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_object_info;
struct _TpSvcChannelClass {
    GObjectClass parent_class;
    tp_svc_channel_close_impl close;
    tp_svc_channel_get_channel_type_impl get_channel_type;
    tp_svc_channel_get_handle_impl get_handle;
    tp_svc_channel_get_interfaces_impl get_interfaces;
};

enum {
    SIGNAL_Closed,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_Closed] =
      g_signal_new ("closed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__VOID,
                    G_TYPE_NONE, 0);

      dbus_g_object_type_install_info (tp_svc_channel_get_type (), &dbus_glib_tp_svc_channel_object_info);
    }
}

GType
tp_svc_channel_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelClass),
      tp_svc_channel_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannel", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_close_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Close
 * on interface org.freedesktop.Telepathy.Channel
 */
static void
tp_svc_channel_close (TpSvcChannel *self,
                      DBusGMethodInvocation *context)
{
  tp_svc_channel_close_impl impl = (TP_SVC_CHANNEL_GET_CLASS (self)->close);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_implement_close:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Close method
 *
 * Register an implementation for the Close method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_implement_close (TpSvcChannelClass *klass, tp_svc_channel_close_impl impl)
{
  klass->close = impl;
}


/**
 * tp_svc_channel_get_channel_type_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetChannelType
 * on interface org.freedesktop.Telepathy.Channel
 */
static void
tp_svc_channel_get_channel_type (TpSvcChannel *self,
                                 DBusGMethodInvocation *context)
{
  tp_svc_channel_get_channel_type_impl impl = (TP_SVC_CHANNEL_GET_CLASS (self)->get_channel_type);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_implement_get_channel_type:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetChannelType method
 *
 * Register an implementation for the GetChannelType method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_implement_get_channel_type (TpSvcChannelClass *klass, tp_svc_channel_get_channel_type_impl impl)
{
  klass->get_channel_type = impl;
}


/**
 * tp_svc_channel_get_handle_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetHandle
 * on interface org.freedesktop.Telepathy.Channel
 */
static void
tp_svc_channel_get_handle (TpSvcChannel *self,
                           DBusGMethodInvocation *context)
{
  tp_svc_channel_get_handle_impl impl = (TP_SVC_CHANNEL_GET_CLASS (self)->get_handle);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_implement_get_handle:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetHandle method
 *
 * Register an implementation for the GetHandle method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_implement_get_handle (TpSvcChannelClass *klass, tp_svc_channel_get_handle_impl impl)
{
  klass->get_handle = impl;
}


/**
 * tp_svc_channel_get_interfaces_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetInterfaces
 * on interface org.freedesktop.Telepathy.Channel
 */
static void
tp_svc_channel_get_interfaces (TpSvcChannel *self,
                               DBusGMethodInvocation *context)
{
  tp_svc_channel_get_interfaces_impl impl = (TP_SVC_CHANNEL_GET_CLASS (self)->get_interfaces);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_implement_get_interfaces:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetInterfaces method
 *
 * Register an implementation for the GetInterfaces method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_implement_get_interfaces (TpSvcChannelClass *klass, tp_svc_channel_get_interfaces_impl impl)
{
  klass->get_interfaces = impl;
}

/**
 * tp_svc_channel_emit_closed:
 * @instance: An object implementing this interface
 *
 * Emit the Closed D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_emit_closed (gpointer instance)
{
  g_assert (TP_IS_SVC_CHANNEL (instance));
  g_signal_emit (instance, signals[SIGNAL_Closed], 0);
}

#include "_gen/svc-Channel-glue.h"

