/*
 * _gen/svc-Channel.h - Header for TpSvcChannel
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_H__
#define __TP_SVC_CHANNEL_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannel:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannel TpSvcChannel;

/**
 * TpSvcChannelClass:
 *
 * The class of TpSvcChannel.
 */
typedef struct _TpSvcChannelClass TpSvcChannelClass;


GType tp_svc_channel_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL \
  (tp_svc_channel_get_type ())
#define TP_SVC_CHANNEL(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL, TpSvcChannel))
#define TP_IS_SVC_CHANNEL(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL))
#define TP_SVC_CHANNEL_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL, TpSvcChannelClass))


typedef void (*tp_svc_channel_close_impl) (TpSvcChannel *self,
                                           DBusGMethodInvocation *context);
void tp_svc_channel_implement_close (TpSvcChannelClass *klass, tp_svc_channel_close_impl impl);


/**
 * tp_svc_channel_return_from_close:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_return_from_close (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_return_from_close (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_channel_get_channel_type_impl) (TpSvcChannel *self,
                                                      DBusGMethodInvocation *context);
void tp_svc_channel_implement_get_channel_type (TpSvcChannelClass *klass, tp_svc_channel_get_channel_type_impl impl);


/**
 * tp_svc_channel_return_from_get_channel_type:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_return_from_get_channel_type (DBusGMethodInvocation *dbus_context,
                                             const gchar *ret)
;
static inline void
tp_svc_channel_return_from_get_channel_type (DBusGMethodInvocation *dbus_context,
                                             const gchar *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_get_handle_impl) (TpSvcChannel *self,
                                                DBusGMethodInvocation *context);
void tp_svc_channel_implement_get_handle (TpSvcChannelClass *klass, tp_svc_channel_get_handle_impl impl);


/**
 * tp_svc_channel_return_from_get_handle:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 * @ret1: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_return_from_get_handle (DBusGMethodInvocation *dbus_context,
                                       guint ret,
                                       guint ret1)
;
static inline void
tp_svc_channel_return_from_get_handle (DBusGMethodInvocation *dbus_context,
                                       guint ret,
                                       guint ret1)
{
  dbus_g_method_return (dbus_context, ret, ret1);
}
typedef void (*tp_svc_channel_get_interfaces_impl) (TpSvcChannel *self,
                                                    DBusGMethodInvocation *context);
void tp_svc_channel_implement_get_interfaces (TpSvcChannelClass *klass, tp_svc_channel_get_interfaces_impl impl);


/**
 * tp_svc_channel_return_from_get_interfaces:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_return_from_get_interfaces (DBusGMethodInvocation *dbus_context,
                                           const gchar **ret)
;
static inline void
tp_svc_channel_return_from_get_interfaces (DBusGMethodInvocation *dbus_context,
                                           const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void tp_svc_channel_emit_closed (gpointer instance);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_H__*/
