/*
 * _gen/svc-Channel_Interface_Chat_State.c - Source for TpSvcChannelInterfaceChatState
 *
 *  Copyright (C) 2007 Collabora Limited 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Interface_Chat_State.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_interface_chat_state_object_info;
struct _TpSvcChannelInterfaceChatStateClass {
    GObjectClass parent_class;
    tp_svc_channel_interface_chat_state_set_chat_state_impl set_chat_state;
};

enum {
    SIGNAL_ChatStateChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_interface_chat_state_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_ChatStateChanged] =
      g_signal_new ("chat-state-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_channel_interface_chat_state_get_type (), &dbus_glib_tp_svc_channel_interface_chat_state_object_info);
    }
}

GType
tp_svc_channel_interface_chat_state_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelInterfaceChatStateClass),
      tp_svc_channel_interface_chat_state_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelInterfaceChatState", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_interface_chat_state_set_chat_state_impl
 * @self: The object implementing this interface
 * @state: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetChatState
 * on interface org.freedesktop.Telepathy.Channel.Interface.ChatState
 */
static void
tp_svc_channel_interface_chat_state_set_chat_state (TpSvcChannelInterfaceChatState *self,
                                                    guint state,
                                                    DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_chat_state_set_chat_state_impl impl = (TP_SVC_CHANNEL_INTERFACE_CHAT_STATE_GET_CLASS (self)->set_chat_state);
  if (impl)
    (impl) (self, state, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_chat_state_implement_set_chat_state:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetChatState method
 *
 * Register an implementation for the SetChatState method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_chat_state_implement_set_chat_state (TpSvcChannelInterfaceChatStateClass *klass, tp_svc_channel_interface_chat_state_set_chat_state_impl impl)
{
  klass->set_chat_state = impl;
}

/**
 * tp_svc_channel_interface_chat_state_emit_chat_state_changed:
 * @instance: An object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @state: FIXME: document args in genginterface
 *
 * Emit the ChatStateChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_interface_chat_state_emit_chat_state_changed (gpointer instance,
    const guint  contact,
    const guint  state)
{
  g_assert (TP_IS_SVC_CHANNEL_INTERFACE_CHAT_STATE (instance));
  g_signal_emit (instance, signals[SIGNAL_ChatStateChanged], 0, contact, state);
}

#include "_gen/svc-Channel_Interface_Chat_State-glue.h"

