/*
 * _gen/svc-Channel_Interface_DTMF.c - Source for TpSvcChannelInterfaceDTMF
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Interface_DTMF.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_interface_dtmf_object_info;
struct _TpSvcChannelInterfaceDTMFClass {
    GObjectClass parent_class;
    tp_svc_channel_interface_dtmf_start_tone_impl start_tone;
    tp_svc_channel_interface_dtmf_stop_tone_impl stop_tone;
};


static void
tp_svc_channel_interface_dtmf_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      dbus_g_object_type_install_info (tp_svc_channel_interface_dtmf_get_type (), &dbus_glib_tp_svc_channel_interface_dtmf_object_info);
    }
}

GType
tp_svc_channel_interface_dtmf_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelInterfaceDTMFClass),
      tp_svc_channel_interface_dtmf_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelInterfaceDTMF", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_interface_dtmf_start_tone_impl
 * @self: The object implementing this interface
 * @stream_id: FIXME: document args in genginterface
 * @event: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method StartTone
 * on interface org.freedesktop.Telepathy.Channel.Interface.DTMF
 */
static void
tp_svc_channel_interface_dtmf_start_tone (TpSvcChannelInterfaceDTMF *self,
                                          guint stream_id,
                                          guchar event,
                                          DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_dtmf_start_tone_impl impl = (TP_SVC_CHANNEL_INTERFACE_DTMF_GET_CLASS (self)->start_tone);
  if (impl)
    (impl) (self, stream_id, event, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_dtmf_implement_start_tone:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the StartTone method
 *
 * Register an implementation for the StartTone method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_dtmf_implement_start_tone (TpSvcChannelInterfaceDTMFClass *klass, tp_svc_channel_interface_dtmf_start_tone_impl impl)
{
  klass->start_tone = impl;
}


/**
 * tp_svc_channel_interface_dtmf_stop_tone_impl
 * @self: The object implementing this interface
 * @stream_id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method StopTone
 * on interface org.freedesktop.Telepathy.Channel.Interface.DTMF
 */
static void
tp_svc_channel_interface_dtmf_stop_tone (TpSvcChannelInterfaceDTMF *self,
                                         guint stream_id,
                                         DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_dtmf_stop_tone_impl impl = (TP_SVC_CHANNEL_INTERFACE_DTMF_GET_CLASS (self)->stop_tone);
  if (impl)
    (impl) (self, stream_id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_dtmf_implement_stop_tone:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the StopTone method
 *
 * Register an implementation for the StopTone method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_dtmf_implement_stop_tone (TpSvcChannelInterfaceDTMFClass *klass, tp_svc_channel_interface_dtmf_stop_tone_impl impl)
{
  klass->stop_tone = impl;
}

#include "_gen/svc-Channel_Interface_DTMF-glue.h"

