/*
 * _gen/svc-Channel_Interface_Media_Signalling.c - Source for TpSvcChannelInterfaceMediaSignalling
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Interface_Media_Signalling.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_interface_media_signalling_object_info;
struct _TpSvcChannelInterfaceMediaSignallingClass {
    GObjectClass parent_class;
    tp_svc_channel_interface_media_signalling_get_session_handlers_impl get_session_handlers;
};

enum {
    SIGNAL_NewSessionHandler,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_interface_media_signalling_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_NewSessionHandler] =
      g_signal_new ("new-session-handler",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_STRING,
                    G_TYPE_NONE, 2, DBUS_TYPE_G_OBJECT_PATH, G_TYPE_STRING);

      dbus_g_object_type_install_info (tp_svc_channel_interface_media_signalling_get_type (), &dbus_glib_tp_svc_channel_interface_media_signalling_object_info);
    }
}

GType
tp_svc_channel_interface_media_signalling_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelInterfaceMediaSignallingClass),
      tp_svc_channel_interface_media_signalling_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelInterfaceMediaSignalling", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_interface_media_signalling_get_session_handlers_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetSessionHandlers
 * on interface org.freedesktop.Telepathy.Channel.Interface.MediaSignalling
 */
static void
tp_svc_channel_interface_media_signalling_get_session_handlers (TpSvcChannelInterfaceMediaSignalling *self,
                                                                DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_media_signalling_get_session_handlers_impl impl = (TP_SVC_CHANNEL_INTERFACE_MEDIA_SIGNALLING_GET_CLASS (self)->get_session_handlers);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_media_signalling_implement_get_session_handlers:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetSessionHandlers method
 *
 * Register an implementation for the GetSessionHandlers method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_media_signalling_implement_get_session_handlers (TpSvcChannelInterfaceMediaSignallingClass *klass, tp_svc_channel_interface_media_signalling_get_session_handlers_impl impl)
{
  klass->get_session_handlers = impl;
}

/**
 * tp_svc_channel_interface_media_signalling_emit_new_session_handler:
 * @instance: An object implementing this interface
 * @session_handler: FIXME: document args in genginterface
 * @type: FIXME: document args in genginterface
 *
 * Emit the NewSessionHandler D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_interface_media_signalling_emit_new_session_handler (gpointer instance,
    const gchar * session_handler,
    const gchar * type)
{
  g_assert (TP_IS_SVC_CHANNEL_INTERFACE_MEDIA_SIGNALLING (instance));
  g_signal_emit (instance, signals[SIGNAL_NewSessionHandler], 0, session_handler, type);
}

#include "_gen/svc-Channel_Interface_Media_Signalling-glue.h"

