/*
 * _gen/svc-Channel_Interface_Password.c - Source for TpSvcChannelInterfacePassword
 *
 * 
Copyright (C) 2005, 2006 Collabora Limited
Copyright (C) 2005, 2006 Nokia Corporation
Copyright (C) 2006 INdT
  
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Interface_Password.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_interface_password_object_info;
struct _TpSvcChannelInterfacePasswordClass {
    GObjectClass parent_class;
    tp_svc_channel_interface_password_get_password_flags_impl get_password_flags;
    tp_svc_channel_interface_password_provide_password_impl provide_password;
};

enum {
    SIGNAL_PasswordFlagsChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_interface_password_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_PasswordFlagsChanged] =
      g_signal_new ("password-flags-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_channel_interface_password_get_type (), &dbus_glib_tp_svc_channel_interface_password_object_info);
    }
}

GType
tp_svc_channel_interface_password_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelInterfacePasswordClass),
      tp_svc_channel_interface_password_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelInterfacePassword", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_interface_password_get_password_flags_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetPasswordFlags
 * on interface org.freedesktop.Telepathy.Channel.Interface.Password
 */
static void
tp_svc_channel_interface_password_get_password_flags (TpSvcChannelInterfacePassword *self,
                                                      DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_password_get_password_flags_impl impl = (TP_SVC_CHANNEL_INTERFACE_PASSWORD_GET_CLASS (self)->get_password_flags);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_password_implement_get_password_flags:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPasswordFlags method
 *
 * Register an implementation for the GetPasswordFlags method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_password_implement_get_password_flags (TpSvcChannelInterfacePasswordClass *klass, tp_svc_channel_interface_password_get_password_flags_impl impl)
{
  klass->get_password_flags = impl;
}


/**
 * tp_svc_channel_interface_password_provide_password_impl
 * @self: The object implementing this interface
 * @password: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ProvidePassword
 * on interface org.freedesktop.Telepathy.Channel.Interface.Password
 */
static void
tp_svc_channel_interface_password_provide_password (TpSvcChannelInterfacePassword *self,
                                                    const gchar *password,
                                                    DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_password_provide_password_impl impl = (TP_SVC_CHANNEL_INTERFACE_PASSWORD_GET_CLASS (self)->provide_password);
  if (impl)
    (impl) (self, password, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_interface_password_implement_provide_password:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ProvidePassword method
 *
 * Register an implementation for the ProvidePassword method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_interface_password_implement_provide_password (TpSvcChannelInterfacePasswordClass *klass, tp_svc_channel_interface_password_provide_password_impl impl)
{
  klass->provide_password = impl;
}

/**
 * tp_svc_channel_interface_password_emit_password_flags_changed:
 * @instance: An object implementing this interface
 * @added: FIXME: document args in genginterface
 * @removed: FIXME: document args in genginterface
 *
 * Emit the PasswordFlagsChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_interface_password_emit_password_flags_changed (gpointer instance,
    const guint  added,
    const guint  removed)
{
  g_assert (TP_IS_SVC_CHANNEL_INTERFACE_PASSWORD (instance));
  g_signal_emit (instance, signals[SIGNAL_PasswordFlagsChanged], 0, added, removed);
}

#include "_gen/svc-Channel_Interface_Password-glue.h"

