/*
 * _gen/svc-Channel_Type_Room_List.c - Source for TpSvcChannelTypeRoomList
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Type_Room_List.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_type_room_list_object_info;
struct _TpSvcChannelTypeRoomListClass {
    GObjectClass parent_class;
    tp_svc_channel_type_room_list_get_listing_rooms_impl get_listing_rooms;
    tp_svc_channel_type_room_list_list_rooms_impl list_rooms;
    tp_svc_channel_type_room_list_stop_listing_impl stop_listing;
};

enum {
    SIGNAL_GotRooms,
    SIGNAL_ListingRooms,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_type_room_list_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_GotRooms] =
      g_signal_new ("got-rooms",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))));

      signals[SIGNAL_ListingRooms] =
      g_signal_new ("listing-rooms",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOOLEAN,
                    G_TYPE_NONE, 1, G_TYPE_BOOLEAN);

      dbus_g_object_type_install_info (tp_svc_channel_type_room_list_get_type (), &dbus_glib_tp_svc_channel_type_room_list_object_info);
    }
}

GType
tp_svc_channel_type_room_list_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelTypeRoomListClass),
      tp_svc_channel_type_room_list_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelTypeRoomList", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_type_room_list_get_listing_rooms_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetListingRooms
 * on interface org.freedesktop.Telepathy.Channel.Type.RoomList
 */
static void
tp_svc_channel_type_room_list_get_listing_rooms (TpSvcChannelTypeRoomList *self,
                                                 DBusGMethodInvocation *context)
{
  tp_svc_channel_type_room_list_get_listing_rooms_impl impl = (TP_SVC_CHANNEL_TYPE_ROOM_LIST_GET_CLASS (self)->get_listing_rooms);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_room_list_implement_get_listing_rooms:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetListingRooms method
 *
 * Register an implementation for the GetListingRooms method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_room_list_implement_get_listing_rooms (TpSvcChannelTypeRoomListClass *klass, tp_svc_channel_type_room_list_get_listing_rooms_impl impl)
{
  klass->get_listing_rooms = impl;
}


/**
 * tp_svc_channel_type_room_list_list_rooms_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListRooms
 * on interface org.freedesktop.Telepathy.Channel.Type.RoomList
 */
static void
tp_svc_channel_type_room_list_list_rooms (TpSvcChannelTypeRoomList *self,
                                          DBusGMethodInvocation *context)
{
  tp_svc_channel_type_room_list_list_rooms_impl impl = (TP_SVC_CHANNEL_TYPE_ROOM_LIST_GET_CLASS (self)->list_rooms);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_room_list_implement_list_rooms:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListRooms method
 *
 * Register an implementation for the ListRooms method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_room_list_implement_list_rooms (TpSvcChannelTypeRoomListClass *klass, tp_svc_channel_type_room_list_list_rooms_impl impl)
{
  klass->list_rooms = impl;
}


/**
 * tp_svc_channel_type_room_list_stop_listing_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method StopListing
 * on interface org.freedesktop.Telepathy.Channel.Type.RoomList
 */
static void
tp_svc_channel_type_room_list_stop_listing (TpSvcChannelTypeRoomList *self,
                                            DBusGMethodInvocation *context)
{
  tp_svc_channel_type_room_list_stop_listing_impl impl = (TP_SVC_CHANNEL_TYPE_ROOM_LIST_GET_CLASS (self)->stop_listing);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_room_list_implement_stop_listing:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the StopListing method
 *
 * Register an implementation for the StopListing method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_room_list_implement_stop_listing (TpSvcChannelTypeRoomListClass *klass, tp_svc_channel_type_room_list_stop_listing_impl impl)
{
  klass->stop_listing = impl;
}

/**
 * tp_svc_channel_type_room_list_emit_got_rooms:
 * @instance: An object implementing this interface
 * @rooms: FIXME: document args in genginterface
 *
 * Emit the GotRooms D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_room_list_emit_got_rooms (gpointer instance,
    const GPtrArray * rooms)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_ROOM_LIST (instance));
  g_signal_emit (instance, signals[SIGNAL_GotRooms], 0, rooms);
}

/**
 * tp_svc_channel_type_room_list_emit_listing_rooms:
 * @instance: An object implementing this interface
 * @listing: FIXME: document args in genginterface
 *
 * Emit the ListingRooms D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_room_list_emit_listing_rooms (gpointer instance,
    const gboolean  listing)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_ROOM_LIST (instance));
  g_signal_emit (instance, signals[SIGNAL_ListingRooms], 0, listing);
}

#include "_gen/svc-Channel_Type_Room_List-glue.h"

