/*
 * _gen/svc-Channel_Type_Text.c - Source for TpSvcChannelTypeText
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Type_Text.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_channel_type_text_object_info;
struct _TpSvcChannelTypeTextClass {
    GObjectClass parent_class;
    tp_svc_channel_type_text_acknowledge_pending_messages_impl acknowledge_pending_messages;
    tp_svc_channel_type_text_get_message_types_impl get_message_types;
    tp_svc_channel_type_text_list_pending_messages_impl list_pending_messages;
    tp_svc_channel_type_text_send_impl send;
};

enum {
    SIGNAL_LostMessage,
    SIGNAL_Received,
    SIGNAL_SendError,
    SIGNAL_Sent,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_type_text_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_LostMessage] =
      g_signal_new ("lost-message",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__VOID,
                    G_TYPE_NONE, 0);

      signals[SIGNAL_Received] =
      g_signal_new ("received",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_UINT_UINT_UINT_STRING,
                    G_TYPE_NONE, 6, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING);

      signals[SIGNAL_SendError] =
      g_signal_new ("send-error",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_UINT_STRING,
                    G_TYPE_NONE, 4, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING);

      signals[SIGNAL_Sent] =
      g_signal_new ("sent",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_STRING,
                    G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING);

      dbus_g_object_type_install_info (tp_svc_channel_type_text_get_type (), &dbus_glib_tp_svc_channel_type_text_object_info);
    }
}

GType
tp_svc_channel_type_text_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelTypeTextClass),
      tp_svc_channel_type_text_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelTypeText", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_type_text_acknowledge_pending_messages_impl
 * @self: The object implementing this interface
 * @ids: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method AcknowledgePendingMessages
 * on interface org.freedesktop.Telepathy.Channel.Type.Text
 */
static void
tp_svc_channel_type_text_acknowledge_pending_messages (TpSvcChannelTypeText *self,
                                                       const GArray *ids,
                                                       DBusGMethodInvocation *context)
{
  tp_svc_channel_type_text_acknowledge_pending_messages_impl impl = (TP_SVC_CHANNEL_TYPE_TEXT_GET_CLASS (self)->acknowledge_pending_messages);
  if (impl)
    (impl) (self, ids, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_text_implement_acknowledge_pending_messages:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcknowledgePendingMessages method
 *
 * Register an implementation for the AcknowledgePendingMessages method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_text_implement_acknowledge_pending_messages (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_acknowledge_pending_messages_impl impl)
{
  klass->acknowledge_pending_messages = impl;
}


/**
 * tp_svc_channel_type_text_get_message_types_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetMessageTypes
 * on interface org.freedesktop.Telepathy.Channel.Type.Text
 */
static void
tp_svc_channel_type_text_get_message_types (TpSvcChannelTypeText *self,
                                            DBusGMethodInvocation *context)
{
  tp_svc_channel_type_text_get_message_types_impl impl = (TP_SVC_CHANNEL_TYPE_TEXT_GET_CLASS (self)->get_message_types);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_text_implement_get_message_types:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetMessageTypes method
 *
 * Register an implementation for the GetMessageTypes method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_text_implement_get_message_types (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_get_message_types_impl impl)
{
  klass->get_message_types = impl;
}


/**
 * tp_svc_channel_type_text_list_pending_messages_impl
 * @self: The object implementing this interface
 * @clear: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListPendingMessages
 * on interface org.freedesktop.Telepathy.Channel.Type.Text
 */
static void
tp_svc_channel_type_text_list_pending_messages (TpSvcChannelTypeText *self,
                                                gboolean clear,
                                                DBusGMethodInvocation *context)
{
  tp_svc_channel_type_text_list_pending_messages_impl impl = (TP_SVC_CHANNEL_TYPE_TEXT_GET_CLASS (self)->list_pending_messages);
  if (impl)
    (impl) (self, clear, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_text_implement_list_pending_messages:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListPendingMessages method
 *
 * Register an implementation for the ListPendingMessages method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_text_implement_list_pending_messages (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_list_pending_messages_impl impl)
{
  klass->list_pending_messages = impl;
}


/**
 * tp_svc_channel_type_text_send_impl
 * @self: The object implementing this interface
 * @type: FIXME: document args in genginterface
 * @text: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Send
 * on interface org.freedesktop.Telepathy.Channel.Type.Text
 */
static void
tp_svc_channel_type_text_send (TpSvcChannelTypeText *self,
                               guint type,
                               const gchar *text,
                               DBusGMethodInvocation *context)
{
  tp_svc_channel_type_text_send_impl impl = (TP_SVC_CHANNEL_TYPE_TEXT_GET_CLASS (self)->send);
  if (impl)
    (impl) (self, type, text, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_channel_type_text_implement_send:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Send method
 *
 * Register an implementation for the Send method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_channel_type_text_implement_send (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_send_impl impl)
{
  klass->send = impl;
}

/**
 * tp_svc_channel_type_text_emit_lost_message:
 * @instance: An object implementing this interface
 *
 * Emit the LostMessage D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_text_emit_lost_message (gpointer instance)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_TEXT (instance));
  g_signal_emit (instance, signals[SIGNAL_LostMessage], 0);
}

/**
 * tp_svc_channel_type_text_emit_received:
 * @instance: An object implementing this interface
 * @id: FIXME: document args in genginterface
 * @timestamp: FIXME: document args in genginterface
 * @sender: FIXME: document args in genginterface
 * @type: FIXME: document args in genginterface
 * @flags: FIXME: document args in genginterface
 * @text: FIXME: document args in genginterface
 *
 * Emit the Received D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_text_emit_received (gpointer instance,
    const guint  id,
    const guint  timestamp,
    const guint  sender,
    const guint  type,
    const guint  flags,
    const gchar * text)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_TEXT (instance));
  g_signal_emit (instance, signals[SIGNAL_Received], 0, id, timestamp, sender, type, flags, text);
}

/**
 * tp_svc_channel_type_text_emit_send_error:
 * @instance: An object implementing this interface
 * @error: FIXME: document args in genginterface
 * @timestamp: FIXME: document args in genginterface
 * @type: FIXME: document args in genginterface
 * @text: FIXME: document args in genginterface
 *
 * Emit the SendError D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_text_emit_send_error (gpointer instance,
    const guint  error,
    const guint  timestamp,
    const guint  type,
    const gchar * text)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_TEXT (instance));
  g_signal_emit (instance, signals[SIGNAL_SendError], 0, error, timestamp, type, text);
}

/**
 * tp_svc_channel_type_text_emit_sent:
 * @instance: An object implementing this interface
 * @timestamp: FIXME: document args in genginterface
 * @type: FIXME: document args in genginterface
 * @text: FIXME: document args in genginterface
 *
 * Emit the Sent D-Bus signal from @instance with the given arguments.
 */
void tp_svc_channel_type_text_emit_sent (gpointer instance,
    const guint  timestamp,
    const guint  type,
    const gchar * text)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_TEXT (instance));
  g_signal_emit (instance, signals[SIGNAL_Sent], 0, timestamp, type, text);
}

#include "_gen/svc-Channel_Type_Text-glue.h"

