/*
 * _gen/svc-Connection.c - Source for TpSvcConnection
 *
 * Copyright (C) 2005, 2006, 2007 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_connection_object_info;
struct _TpSvcConnectionClass {
    GObjectClass parent_class;
    tp_svc_connection_connect_impl connect;
    tp_svc_connection_disconnect_impl disconnect;
    tp_svc_connection_get_interfaces_impl get_interfaces;
    tp_svc_connection_get_protocol_impl get_protocol;
    tp_svc_connection_get_self_handle_impl get_self_handle;
    tp_svc_connection_get_status_impl get_status;
    tp_svc_connection_hold_handles_impl hold_handles;
    tp_svc_connection_inspect_handles_impl inspect_handles;
    tp_svc_connection_list_channels_impl list_channels;
    tp_svc_connection_release_handles_impl release_handles;
    tp_svc_connection_request_channel_impl request_channel;
    tp_svc_connection_request_handles_impl request_handles;
};

enum {
    SIGNAL_NewChannel,
    SIGNAL_StatusChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_NewChannel] =
      g_signal_new ("new-channel",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_STRING_UINT_UINT_BOOLEAN,
                    G_TYPE_NONE, 5, DBUS_TYPE_G_OBJECT_PATH, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_BOOLEAN);

      signals[SIGNAL_StatusChanged] =
      g_signal_new ("status-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_connection_get_type (), &dbus_glib_tp_svc_connection_object_info);
    }
}

GType
tp_svc_connection_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionClass),
      tp_svc_connection_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnection", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_connect_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Connect
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_connect (TpSvcConnection *self,
                           DBusGMethodInvocation *context)
{
  tp_svc_connection_connect_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->connect);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_connect:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Connect method
 *
 * Register an implementation for the Connect method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_connect (TpSvcConnectionClass *klass, tp_svc_connection_connect_impl impl)
{
  klass->connect = impl;
}


/**
 * tp_svc_connection_disconnect_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Disconnect
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_disconnect (TpSvcConnection *self,
                              DBusGMethodInvocation *context)
{
  tp_svc_connection_disconnect_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->disconnect);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_disconnect:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Disconnect method
 *
 * Register an implementation for the Disconnect method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_disconnect (TpSvcConnectionClass *klass, tp_svc_connection_disconnect_impl impl)
{
  klass->disconnect = impl;
}


/**
 * tp_svc_connection_get_interfaces_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetInterfaces
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_get_interfaces (TpSvcConnection *self,
                                  DBusGMethodInvocation *context)
{
  tp_svc_connection_get_interfaces_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->get_interfaces);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_get_interfaces:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetInterfaces method
 *
 * Register an implementation for the GetInterfaces method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_get_interfaces (TpSvcConnectionClass *klass, tp_svc_connection_get_interfaces_impl impl)
{
  klass->get_interfaces = impl;
}


/**
 * tp_svc_connection_get_protocol_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetProtocol
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_get_protocol (TpSvcConnection *self,
                                DBusGMethodInvocation *context)
{
  tp_svc_connection_get_protocol_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->get_protocol);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_get_protocol:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProtocol method
 *
 * Register an implementation for the GetProtocol method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_get_protocol (TpSvcConnectionClass *klass, tp_svc_connection_get_protocol_impl impl)
{
  klass->get_protocol = impl;
}


/**
 * tp_svc_connection_get_self_handle_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetSelfHandle
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_get_self_handle (TpSvcConnection *self,
                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_get_self_handle_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->get_self_handle);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_get_self_handle:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetSelfHandle method
 *
 * Register an implementation for the GetSelfHandle method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_get_self_handle (TpSvcConnectionClass *klass, tp_svc_connection_get_self_handle_impl impl)
{
  klass->get_self_handle = impl;
}


/**
 * tp_svc_connection_get_status_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetStatus
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_get_status (TpSvcConnection *self,
                              DBusGMethodInvocation *context)
{
  tp_svc_connection_get_status_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->get_status);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_get_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetStatus method
 *
 * Register an implementation for the GetStatus method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_get_status (TpSvcConnectionClass *klass, tp_svc_connection_get_status_impl impl)
{
  klass->get_status = impl;
}


/**
 * tp_svc_connection_hold_handles_impl
 * @self: The object implementing this interface
 * @handle_type: FIXME: document args in genginterface
 * @handles: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method HoldHandles
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_hold_handles (TpSvcConnection *self,
                                guint handle_type,
                                const GArray *handles,
                                DBusGMethodInvocation *context)
{
  tp_svc_connection_hold_handles_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->hold_handles);
  if (impl)
    (impl) (self, handle_type, handles, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_hold_handles:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HoldHandles method
 *
 * Register an implementation for the HoldHandles method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_hold_handles (TpSvcConnectionClass *klass, tp_svc_connection_hold_handles_impl impl)
{
  klass->hold_handles = impl;
}


/**
 * tp_svc_connection_inspect_handles_impl
 * @self: The object implementing this interface
 * @handle_type: FIXME: document args in genginterface
 * @handles: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method InspectHandles
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_inspect_handles (TpSvcConnection *self,
                                   guint handle_type,
                                   const GArray *handles,
                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_inspect_handles_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->inspect_handles);
  if (impl)
    (impl) (self, handle_type, handles, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_inspect_handles:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the InspectHandles method
 *
 * Register an implementation for the InspectHandles method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_inspect_handles (TpSvcConnectionClass *klass, tp_svc_connection_inspect_handles_impl impl)
{
  klass->inspect_handles = impl;
}


/**
 * tp_svc_connection_list_channels_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListChannels
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_list_channels (TpSvcConnection *self,
                                 DBusGMethodInvocation *context)
{
  tp_svc_connection_list_channels_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->list_channels);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_list_channels:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListChannels method
 *
 * Register an implementation for the ListChannels method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_list_channels (TpSvcConnectionClass *klass, tp_svc_connection_list_channels_impl impl)
{
  klass->list_channels = impl;
}


/**
 * tp_svc_connection_release_handles_impl
 * @self: The object implementing this interface
 * @handle_type: FIXME: document args in genginterface
 * @handles: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ReleaseHandles
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_release_handles (TpSvcConnection *self,
                                   guint handle_type,
                                   const GArray *handles,
                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_release_handles_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->release_handles);
  if (impl)
    (impl) (self, handle_type, handles, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_release_handles:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ReleaseHandles method
 *
 * Register an implementation for the ReleaseHandles method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_release_handles (TpSvcConnectionClass *klass, tp_svc_connection_release_handles_impl impl)
{
  klass->release_handles = impl;
}


/**
 * tp_svc_connection_request_channel_impl
 * @self: The object implementing this interface
 * @type: FIXME: document args in genginterface
 * @handle_type: FIXME: document args in genginterface
 * @handle: FIXME: document args in genginterface
 * @suppress_handler: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestChannel
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_request_channel (TpSvcConnection *self,
                                   const gchar *type,
                                   guint handle_type,
                                   guint handle,
                                   gboolean suppress_handler,
                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_request_channel_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->request_channel);
  if (impl)
    (impl) (self, type, handle_type, handle, suppress_handler, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_request_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestChannel method
 *
 * Register an implementation for the RequestChannel method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_request_channel (TpSvcConnectionClass *klass, tp_svc_connection_request_channel_impl impl)
{
  klass->request_channel = impl;
}


/**
 * tp_svc_connection_request_handles_impl
 * @self: The object implementing this interface
 * @handle_type: FIXME: document args in genginterface
 * @names: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestHandles
 * on interface org.freedesktop.Telepathy.Connection
 */
static void
tp_svc_connection_request_handles (TpSvcConnection *self,
                                   guint handle_type,
                                   const gchar **names,
                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_request_handles_impl impl = (TP_SVC_CONNECTION_GET_CLASS (self)->request_handles);
  if (impl)
    (impl) (self, handle_type, names, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_implement_request_handles:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestHandles method
 *
 * Register an implementation for the RequestHandles method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_implement_request_handles (TpSvcConnectionClass *klass, tp_svc_connection_request_handles_impl impl)
{
  klass->request_handles = impl;
}

/**
 * tp_svc_connection_emit_new_channel:
 * @instance: An object implementing this interface
 * @object_path: FIXME: document args in genginterface
 * @channel_type: FIXME: document args in genginterface
 * @handle_type: FIXME: document args in genginterface
 * @handle: FIXME: document args in genginterface
 * @suppress_handler: FIXME: document args in genginterface
 *
 * Emit the NewChannel D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_emit_new_channel (gpointer instance,
    const gchar * object_path,
    const gchar * channel_type,
    const guint  handle_type,
    const guint  handle,
    const gboolean  suppress_handler)
{
  g_assert (TP_IS_SVC_CONNECTION (instance));
  g_signal_emit (instance, signals[SIGNAL_NewChannel], 0, object_path, channel_type, handle_type, handle, suppress_handler);
}

/**
 * tp_svc_connection_emit_status_changed:
 * @instance: An object implementing this interface
 * @status: FIXME: document args in genginterface
 * @reason: FIXME: document args in genginterface
 *
 * Emit the StatusChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_emit_status_changed (gpointer instance,
    const guint  status,
    const guint  reason)
{
  g_assert (TP_IS_SVC_CONNECTION (instance));
  g_signal_emit (instance, signals[SIGNAL_StatusChanged], 0, status, reason);
}

#include "_gen/svc-Connection-glue.h"

