/*
 * _gen/svc-Connection_Interface_Aliasing.c - Source for TpSvcConnectionInterfaceAliasing
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection_Interface_Aliasing.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_connection_interface_aliasing_object_info;
struct _TpSvcConnectionInterfaceAliasingClass {
    GObjectClass parent_class;
    tp_svc_connection_interface_aliasing_get_alias_flags_impl get_alias_flags;
    tp_svc_connection_interface_aliasing_request_aliases_impl request_aliases;
    tp_svc_connection_interface_aliasing_set_aliases_impl set_aliases;
};

enum {
    SIGNAL_AliasesChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_interface_aliasing_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_AliasesChanged] =
      g_signal_new ("aliases-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_INVALID)))));

      dbus_g_object_type_install_info (tp_svc_connection_interface_aliasing_get_type (), &dbus_glib_tp_svc_connection_interface_aliasing_object_info);
    }
}

GType
tp_svc_connection_interface_aliasing_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionInterfaceAliasingClass),
      tp_svc_connection_interface_aliasing_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnectionInterfaceAliasing", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_interface_aliasing_get_alias_flags_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetAliasFlags
 * on interface org.freedesktop.Telepathy.Connection.Interface.Aliasing
 */
static void
tp_svc_connection_interface_aliasing_get_alias_flags (TpSvcConnectionInterfaceAliasing *self,
                                                      DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_aliasing_get_alias_flags_impl impl = (TP_SVC_CONNECTION_INTERFACE_ALIASING_GET_CLASS (self)->get_alias_flags);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_aliasing_implement_get_alias_flags:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetAliasFlags method
 *
 * Register an implementation for the GetAliasFlags method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_aliasing_implement_get_alias_flags (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_get_alias_flags_impl impl)
{
  klass->get_alias_flags = impl;
}


/**
 * tp_svc_connection_interface_aliasing_request_aliases_impl
 * @self: The object implementing this interface
 * @contacts: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestAliases
 * on interface org.freedesktop.Telepathy.Connection.Interface.Aliasing
 */
static void
tp_svc_connection_interface_aliasing_request_aliases (TpSvcConnectionInterfaceAliasing *self,
                                                      const GArray *contacts,
                                                      DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_aliasing_request_aliases_impl impl = (TP_SVC_CONNECTION_INTERFACE_ALIASING_GET_CLASS (self)->request_aliases);
  if (impl)
    (impl) (self, contacts, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_aliasing_implement_request_aliases:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestAliases method
 *
 * Register an implementation for the RequestAliases method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_aliasing_implement_request_aliases (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_request_aliases_impl impl)
{
  klass->request_aliases = impl;
}


/**
 * tp_svc_connection_interface_aliasing_set_aliases_impl
 * @self: The object implementing this interface
 * @aliases: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetAliases
 * on interface org.freedesktop.Telepathy.Connection.Interface.Aliasing
 */
static void
tp_svc_connection_interface_aliasing_set_aliases (TpSvcConnectionInterfaceAliasing *self,
                                                  GHashTable *aliases,
                                                  DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_aliasing_set_aliases_impl impl = (TP_SVC_CONNECTION_INTERFACE_ALIASING_GET_CLASS (self)->set_aliases);
  if (impl)
    (impl) (self, aliases, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_aliasing_implement_set_aliases:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetAliases method
 *
 * Register an implementation for the SetAliases method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_aliasing_implement_set_aliases (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_set_aliases_impl impl)
{
  klass->set_aliases = impl;
}

/**
 * tp_svc_connection_interface_aliasing_emit_aliases_changed:
 * @instance: An object implementing this interface
 * @aliases: FIXME: document args in genginterface
 *
 * Emit the AliasesChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_interface_aliasing_emit_aliases_changed (gpointer instance,
    const GPtrArray * aliases)
{
  g_assert (TP_IS_SVC_CONNECTION_INTERFACE_ALIASING (instance));
  g_signal_emit (instance, signals[SIGNAL_AliasesChanged], 0, aliases);
}

#include "_gen/svc-Connection_Interface_Aliasing-glue.h"

