/*
 * _gen/svc-Connection_Interface_Aliasing.h - Header for TpSvcConnectionInterfaceAliasing
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_INTERFACE_ALIASING_H__
#define __TP_SVC_CONNECTION_INTERFACE_ALIASING_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcConnectionInterfaceAliasing:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcConnectionInterfaceAliasing TpSvcConnectionInterfaceAliasing;

/**
 * TpSvcConnectionInterfaceAliasingClass:
 *
 * The class of TpSvcConnectionInterfaceAliasing.
 */
typedef struct _TpSvcConnectionInterfaceAliasingClass TpSvcConnectionInterfaceAliasingClass;


GType tp_svc_connection_interface_aliasing_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_INTERFACE_ALIASING \
  (tp_svc_connection_interface_aliasing_get_type ())
#define TP_SVC_CONNECTION_INTERFACE_ALIASING(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_ALIASING, TpSvcConnectionInterfaceAliasing))
#define TP_IS_SVC_CONNECTION_INTERFACE_ALIASING(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_ALIASING))
#define TP_SVC_CONNECTION_INTERFACE_ALIASING_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_ALIASING, TpSvcConnectionInterfaceAliasingClass))


typedef void (*tp_svc_connection_interface_aliasing_get_alias_flags_impl) (TpSvcConnectionInterfaceAliasing *self,
                                                                           DBusGMethodInvocation *context);
void tp_svc_connection_interface_aliasing_implement_get_alias_flags (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_get_alias_flags_impl impl);


/**
 * tp_svc_connection_interface_aliasing_return_from_get_alias_flags:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_aliasing_return_from_get_alias_flags (DBusGMethodInvocation *dbus_context,
                                                                  guint ret)
;
static inline void
tp_svc_connection_interface_aliasing_return_from_get_alias_flags (DBusGMethodInvocation *dbus_context,
                                                                  guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_aliasing_request_aliases_impl) (TpSvcConnectionInterfaceAliasing *self,
                                                                           const GArray *contacts,
                                                                           DBusGMethodInvocation *context);
void tp_svc_connection_interface_aliasing_implement_request_aliases (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_request_aliases_impl impl);


/**
 * tp_svc_connection_interface_aliasing_return_from_request_aliases:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_aliasing_return_from_request_aliases (DBusGMethodInvocation *dbus_context,
                                                                  const gchar **ret)
;
static inline void
tp_svc_connection_interface_aliasing_return_from_request_aliases (DBusGMethodInvocation *dbus_context,
                                                                  const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_aliasing_set_aliases_impl) (TpSvcConnectionInterfaceAliasing *self,
                                                                       GHashTable *aliases,
                                                                       DBusGMethodInvocation *context);
void tp_svc_connection_interface_aliasing_implement_set_aliases (TpSvcConnectionInterfaceAliasingClass *klass, tp_svc_connection_interface_aliasing_set_aliases_impl impl);


/**
 * tp_svc_connection_interface_aliasing_return_from_set_aliases:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_aliasing_return_from_set_aliases (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_aliasing_return_from_set_aliases (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_connection_interface_aliasing_emit_aliases_changed (gpointer instance,
    const GPtrArray * aliases);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_INTERFACE_ALIASING_H__*/
