/*
 * _gen/svc-Connection_Interface_Capabilities.c - Source for TpSvcConnectionInterfaceCapabilities
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection_Interface_Capabilities.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_connection_interface_capabilities_object_info;
struct _TpSvcConnectionInterfaceCapabilitiesClass {
    GObjectClass parent_class;
    tp_svc_connection_interface_capabilities_advertise_capabilities_impl advertise_capabilities;
    tp_svc_connection_interface_capabilities_get_capabilities_impl get_capabilities;
};

enum {
    SIGNAL_CapabilitiesChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_interface_capabilities_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_CapabilitiesChanged] =
      g_signal_new ("capabilities-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)))));

      dbus_g_object_type_install_info (tp_svc_connection_interface_capabilities_get_type (), &dbus_glib_tp_svc_connection_interface_capabilities_object_info);
    }
}

GType
tp_svc_connection_interface_capabilities_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionInterfaceCapabilitiesClass),
      tp_svc_connection_interface_capabilities_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnectionInterfaceCapabilities", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_interface_capabilities_advertise_capabilities_impl
 * @self: The object implementing this interface
 * @add: FIXME: document args in genginterface
 * @remove: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method AdvertiseCapabilities
 * on interface org.freedesktop.Telepathy.Connection.Interface.Capabilities
 */
static void
tp_svc_connection_interface_capabilities_advertise_capabilities (TpSvcConnectionInterfaceCapabilities *self,
                                                                 const GPtrArray *add,
                                                                 const gchar **remove,
                                                                 DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_capabilities_advertise_capabilities_impl impl = (TP_SVC_CONNECTION_INTERFACE_CAPABILITIES_GET_CLASS (self)->advertise_capabilities);
  if (impl)
    (impl) (self, add, remove, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_capabilities_implement_advertise_capabilities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AdvertiseCapabilities method
 *
 * Register an implementation for the AdvertiseCapabilities method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_capabilities_implement_advertise_capabilities (TpSvcConnectionInterfaceCapabilitiesClass *klass, tp_svc_connection_interface_capabilities_advertise_capabilities_impl impl)
{
  klass->advertise_capabilities = impl;
}


/**
 * tp_svc_connection_interface_capabilities_get_capabilities_impl
 * @self: The object implementing this interface
 * @handles: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetCapabilities
 * on interface org.freedesktop.Telepathy.Connection.Interface.Capabilities
 */
static void
tp_svc_connection_interface_capabilities_get_capabilities (TpSvcConnectionInterfaceCapabilities *self,
                                                           const GArray *handles,
                                                           DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_capabilities_get_capabilities_impl impl = (TP_SVC_CONNECTION_INTERFACE_CAPABILITIES_GET_CLASS (self)->get_capabilities);
  if (impl)
    (impl) (self, handles, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_capabilities_implement_get_capabilities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCapabilities method
 *
 * Register an implementation for the GetCapabilities method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_capabilities_implement_get_capabilities (TpSvcConnectionInterfaceCapabilitiesClass *klass, tp_svc_connection_interface_capabilities_get_capabilities_impl impl)
{
  klass->get_capabilities = impl;
}

/**
 * tp_svc_connection_interface_capabilities_emit_capabilities_changed:
 * @instance: An object implementing this interface
 * @caps: FIXME: document args in genginterface
 *
 * Emit the CapabilitiesChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_interface_capabilities_emit_capabilities_changed (gpointer instance,
    const GPtrArray * caps)
{
  g_assert (TP_IS_SVC_CONNECTION_INTERFACE_CAPABILITIES (instance));
  g_signal_emit (instance, signals[SIGNAL_CapabilitiesChanged], 0, caps);
}

#include "_gen/svc-Connection_Interface_Capabilities-glue.h"

