/*
 * _gen/svc-Connection_Interface_Presence.c - Source for TpSvcConnectionInterfacePresence
 *
 * 
    Copyright (C) 2005, 2006 Collabora Limited
  
 * 
Copyright (C) 2005, 2006 Nokia Corporation
  
 * 
Copyright (C) 2006 INdT
  
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection_Interface_Presence.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_connection_interface_presence_object_info;
struct _TpSvcConnectionInterfacePresenceClass {
    GObjectClass parent_class;
    tp_svc_connection_interface_presence_add_status_impl add_status;
    tp_svc_connection_interface_presence_clear_status_impl clear_status;
    tp_svc_connection_interface_presence_get_presence_impl get_presence;
    tp_svc_connection_interface_presence_get_statuses_impl get_statuses;
    tp_svc_connection_interface_presence_remove_status_impl remove_status;
    tp_svc_connection_interface_presence_request_presence_impl request_presence;
    tp_svc_connection_interface_presence_set_last_activity_time_impl set_last_activity_time;
    tp_svc_connection_interface_presence_set_status_impl set_status;
};

enum {
    SIGNAL_PresenceUpdate,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_interface_presence_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_PresenceUpdate] =
      g_signal_new ("presence-update",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)))), G_TYPE_INVALID)))));

      dbus_g_object_type_install_info (tp_svc_connection_interface_presence_get_type (), &dbus_glib_tp_svc_connection_interface_presence_object_info);
    }
}

GType
tp_svc_connection_interface_presence_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionInterfacePresenceClass),
      tp_svc_connection_interface_presence_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnectionInterfacePresence", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_interface_presence_add_status_impl
 * @self: The object implementing this interface
 * @status: FIXME: document args in genginterface
 * @parms: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method AddStatus
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_add_status (TpSvcConnectionInterfacePresence *self,
                                                 const gchar *status,
                                                 GHashTable *parms,
                                                 DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_add_status_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->add_status);
  if (impl)
    (impl) (self, status, parms, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_add_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AddStatus method
 *
 * Register an implementation for the AddStatus method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_add_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_add_status_impl impl)
{
  klass->add_status = impl;
}


/**
 * tp_svc_connection_interface_presence_clear_status_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ClearStatus
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_clear_status (TpSvcConnectionInterfacePresence *self,
                                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_clear_status_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->clear_status);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_clear_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ClearStatus method
 *
 * Register an implementation for the ClearStatus method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_clear_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_clear_status_impl impl)
{
  klass->clear_status = impl;
}


/**
 * tp_svc_connection_interface_presence_get_presence_impl
 * @self: The object implementing this interface
 * @contacts: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetPresence
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_get_presence (TpSvcConnectionInterfacePresence *self,
                                                   const GArray *contacts,
                                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_get_presence_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->get_presence);
  if (impl)
    (impl) (self, contacts, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_get_presence:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPresence method
 *
 * Register an implementation for the GetPresence method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_get_presence (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_get_presence_impl impl)
{
  klass->get_presence = impl;
}


/**
 * tp_svc_connection_interface_presence_get_statuses_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetStatuses
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_get_statuses (TpSvcConnectionInterfacePresence *self,
                                                   DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_get_statuses_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->get_statuses);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_get_statuses:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetStatuses method
 *
 * Register an implementation for the GetStatuses method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_get_statuses (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_get_statuses_impl impl)
{
  klass->get_statuses = impl;
}


/**
 * tp_svc_connection_interface_presence_remove_status_impl
 * @self: The object implementing this interface
 * @status: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RemoveStatus
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_remove_status (TpSvcConnectionInterfacePresence *self,
                                                    const gchar *status,
                                                    DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_remove_status_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->remove_status);
  if (impl)
    (impl) (self, status, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_remove_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RemoveStatus method
 *
 * Register an implementation for the RemoveStatus method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_remove_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_remove_status_impl impl)
{
  klass->remove_status = impl;
}


/**
 * tp_svc_connection_interface_presence_request_presence_impl
 * @self: The object implementing this interface
 * @contacts: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestPresence
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_request_presence (TpSvcConnectionInterfacePresence *self,
                                                       const GArray *contacts,
                                                       DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_request_presence_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->request_presence);
  if (impl)
    (impl) (self, contacts, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_request_presence:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestPresence method
 *
 * Register an implementation for the RequestPresence method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_request_presence (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_request_presence_impl impl)
{
  klass->request_presence = impl;
}


/**
 * tp_svc_connection_interface_presence_set_last_activity_time_impl
 * @self: The object implementing this interface
 * @time: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetLastActivityTime
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_set_last_activity_time (TpSvcConnectionInterfacePresence *self,
                                                             guint time,
                                                             DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_set_last_activity_time_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->set_last_activity_time);
  if (impl)
    (impl) (self, time, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_set_last_activity_time:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetLastActivityTime method
 *
 * Register an implementation for the SetLastActivityTime method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_set_last_activity_time (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_set_last_activity_time_impl impl)
{
  klass->set_last_activity_time = impl;
}


/**
 * tp_svc_connection_interface_presence_set_status_impl
 * @self: The object implementing this interface
 * @statuses: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetStatus
 * on interface org.freedesktop.Telepathy.Connection.Interface.Presence
 */
static void
tp_svc_connection_interface_presence_set_status (TpSvcConnectionInterfacePresence *self,
                                                 GHashTable *statuses,
                                                 DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_presence_set_status_impl impl = (TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS (self)->set_status);
  if (impl)
    (impl) (self, statuses, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_interface_presence_implement_set_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetStatus method
 *
 * Register an implementation for the SetStatus method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_interface_presence_implement_set_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_set_status_impl impl)
{
  klass->set_status = impl;
}

/**
 * tp_svc_connection_interface_presence_emit_presence_update:
 * @instance: An object implementing this interface
 * @presence: FIXME: document args in genginterface
 *
 * Emit the PresenceUpdate D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_interface_presence_emit_presence_update (gpointer instance,
    const GHashTable * presence)
{
  g_assert (TP_IS_SVC_CONNECTION_INTERFACE_PRESENCE (instance));
  g_signal_emit (instance, signals[SIGNAL_PresenceUpdate], 0, presence);
}

#include "_gen/svc-Connection_Interface_Presence-glue.h"

