/*
 * _gen/svc-Connection_Manager.c - Source for TpSvcConnectionManager
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection_Manager.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_connection_manager_object_info;
struct _TpSvcConnectionManagerClass {
    GObjectClass parent_class;
    tp_svc_connection_manager_get_parameters_impl get_parameters;
    tp_svc_connection_manager_list_protocols_impl list_protocols;
    tp_svc_connection_manager_request_connection_impl request_connection;
};

enum {
    SIGNAL_NewConnection,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_manager_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_NewConnection] =
      g_signal_new ("new-connection",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_STRING_STRING,
                    G_TYPE_NONE, 3, G_TYPE_STRING, DBUS_TYPE_G_OBJECT_PATH, G_TYPE_STRING);

      dbus_g_object_type_install_info (tp_svc_connection_manager_get_type (), &dbus_glib_tp_svc_connection_manager_object_info);
    }
}

GType
tp_svc_connection_manager_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionManagerClass),
      tp_svc_connection_manager_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnectionManager", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_manager_get_parameters_impl
 * @self: The object implementing this interface
 * @proto: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetParameters
 * on interface org.freedesktop.Telepathy.ConnectionManager
 */
static void
tp_svc_connection_manager_get_parameters (TpSvcConnectionManager *self,
                                          const gchar *proto,
                                          DBusGMethodInvocation *context)
{
  tp_svc_connection_manager_get_parameters_impl impl = (TP_SVC_CONNECTION_MANAGER_GET_CLASS (self)->get_parameters);
  if (impl)
    (impl) (self, proto, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_manager_implement_get_parameters:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetParameters method
 *
 * Register an implementation for the GetParameters method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_manager_implement_get_parameters (TpSvcConnectionManagerClass *klass, tp_svc_connection_manager_get_parameters_impl impl)
{
  klass->get_parameters = impl;
}


/**
 * tp_svc_connection_manager_list_protocols_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListProtocols
 * on interface org.freedesktop.Telepathy.ConnectionManager
 */
static void
tp_svc_connection_manager_list_protocols (TpSvcConnectionManager *self,
                                          DBusGMethodInvocation *context)
{
  tp_svc_connection_manager_list_protocols_impl impl = (TP_SVC_CONNECTION_MANAGER_GET_CLASS (self)->list_protocols);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_manager_implement_list_protocols:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListProtocols method
 *
 * Register an implementation for the ListProtocols method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_manager_implement_list_protocols (TpSvcConnectionManagerClass *klass, tp_svc_connection_manager_list_protocols_impl impl)
{
  klass->list_protocols = impl;
}


/**
 * tp_svc_connection_manager_request_connection_impl
 * @self: The object implementing this interface
 * @proto: FIXME: document args in genginterface
 * @parameters: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestConnection
 * on interface org.freedesktop.Telepathy.ConnectionManager
 */
static void
tp_svc_connection_manager_request_connection (TpSvcConnectionManager *self,
                                              const gchar *proto,
                                              GHashTable *parameters,
                                              DBusGMethodInvocation *context)
{
  tp_svc_connection_manager_request_connection_impl impl = (TP_SVC_CONNECTION_MANAGER_GET_CLASS (self)->request_connection);
  if (impl)
    (impl) (self, proto, parameters, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_connection_manager_implement_request_connection:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestConnection method
 *
 * Register an implementation for the RequestConnection method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_connection_manager_implement_request_connection (TpSvcConnectionManagerClass *klass, tp_svc_connection_manager_request_connection_impl impl)
{
  klass->request_connection = impl;
}

/**
 * tp_svc_connection_manager_emit_new_connection:
 * @instance: An object implementing this interface
 * @bus_name: FIXME: document args in genginterface
 * @object_path: FIXME: document args in genginterface
 * @proto: FIXME: document args in genginterface
 *
 * Emit the NewConnection D-Bus signal from @instance with the given arguments.
 */
void tp_svc_connection_manager_emit_new_connection (gpointer instance,
    const gchar * bus_name,
    const gchar * object_path,
    const gchar * proto)
{
  g_assert (TP_IS_SVC_CONNECTION_MANAGER (instance));
  g_signal_emit (instance, signals[SIGNAL_NewConnection], 0, bus_name, object_path, proto);
}

#include "_gen/svc-Connection_Manager-glue.h"

