/*
 * _gen/svc-Media_Session_Handler.c - Source for TpSvcMediaSessionHandler
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Media_Session_Handler.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_media_session_handler_object_info;
struct _TpSvcMediaSessionHandlerClass {
    GObjectClass parent_class;
    tp_svc_media_session_handler_error_impl error;
    tp_svc_media_session_handler_ready_impl ready;
};

enum {
    SIGNAL_NewStreamHandler,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_media_session_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_NewStreamHandler] =
      g_signal_new ("new-stream-handler",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_UINT_UINT_UINT,
                    G_TYPE_NONE, 4, DBUS_TYPE_G_OBJECT_PATH, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_media_session_handler_get_type (), &dbus_glib_tp_svc_media_session_handler_object_info);
    }
}

GType
tp_svc_media_session_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcMediaSessionHandlerClass),
      tp_svc_media_session_handler_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcMediaSessionHandler", &info, 0);
  }

  return type;
}


/**
 * tp_svc_media_session_handler_error_impl
 * @self: The object implementing this interface
 * @errno: FIXME: document args in genginterface
 * @message: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Error
 * on interface org.freedesktop.Telepathy.Media.SessionHandler
 */
static void
tp_svc_media_session_handler_error (TpSvcMediaSessionHandler *self,
                                    guint errno,
                                    const gchar *message,
                                    DBusGMethodInvocation *context)
{
  tp_svc_media_session_handler_error_impl impl = (TP_SVC_MEDIA_SESSION_HANDLER_GET_CLASS (self)->error);
  if (impl)
    (impl) (self, errno, message, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_session_handler_implement_error:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Error method
 *
 * Register an implementation for the Error method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_session_handler_implement_error (TpSvcMediaSessionHandlerClass *klass, tp_svc_media_session_handler_error_impl impl)
{
  klass->error = impl;
}


/**
 * tp_svc_media_session_handler_ready_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Ready
 * on interface org.freedesktop.Telepathy.Media.SessionHandler
 */
static void
tp_svc_media_session_handler_ready (TpSvcMediaSessionHandler *self,
                                    DBusGMethodInvocation *context)
{
  tp_svc_media_session_handler_ready_impl impl = (TP_SVC_MEDIA_SESSION_HANDLER_GET_CLASS (self)->ready);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_session_handler_implement_ready:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Ready method
 *
 * Register an implementation for the Ready method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_session_handler_implement_ready (TpSvcMediaSessionHandlerClass *klass, tp_svc_media_session_handler_ready_impl impl)
{
  klass->ready = impl;
}

/**
 * tp_svc_media_session_handler_emit_new_stream_handler:
 * @instance: An object implementing this interface
 * @stream_handler: FIXME: document args in genginterface
 * @id: FIXME: document args in genginterface
 * @media_type: FIXME: document args in genginterface
 * @direction: FIXME: document args in genginterface
 *
 * Emit the NewStreamHandler D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_session_handler_emit_new_stream_handler (gpointer instance,
    const gchar * stream_handler,
    const guint  id,
    const guint  media_type,
    const guint  direction)
{
  g_assert (TP_IS_SVC_MEDIA_SESSION_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_NewStreamHandler], 0, stream_handler, id, media_type, direction);
}

#include "_gen/svc-Media_Session_Handler-glue.h"

