/*
 * _gen/svc-Media_Stream_Handler.c - Source for TpSvcMediaStreamHandler
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Media_Stream_Handler.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_media_stream_handler_object_info;
struct _TpSvcMediaStreamHandlerClass {
    GObjectClass parent_class;
    tp_svc_media_stream_handler_codec_choice_impl codec_choice;
    tp_svc_media_stream_handler_error_impl error;
    tp_svc_media_stream_handler_native_candidates_prepared_impl native_candidates_prepared;
    tp_svc_media_stream_handler_new_active_candidate_pair_impl new_active_candidate_pair;
    tp_svc_media_stream_handler_new_native_candidate_impl new_native_candidate;
    tp_svc_media_stream_handler_ready_impl ready;
    tp_svc_media_stream_handler_set_local_codecs_impl set_local_codecs;
    tp_svc_media_stream_handler_stream_state_impl stream_state;
    tp_svc_media_stream_handler_supported_codecs_impl supported_codecs;
};

enum {
    SIGNAL_AddRemoteCandidate,
    SIGNAL_Close,
    SIGNAL_RemoveRemoteCandidate,
    SIGNAL_SetActiveCandidatePair,
    SIGNAL_SetRemoteCandidateList,
    SIGNAL_SetRemoteCodecs,
    SIGNAL_SetStreamPlaying,
    SIGNAL_SetStreamSending,
    SIGNAL_StartTelephonyEvent,
    SIGNAL_StopTelephonyEvent,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_media_stream_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_AddRemoteCandidate] =
      g_signal_new ("add-remote-candidate",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_BOXED,
                    G_TYPE_NONE, 2, G_TYPE_STRING, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INVALID)))));

      signals[SIGNAL_Close] =
      g_signal_new ("close",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__VOID,
                    G_TYPE_NONE, 0);

      signals[SIGNAL_RemoveRemoteCandidate] =
      g_signal_new ("remove-remote-candidate",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__STRING,
                    G_TYPE_NONE, 1, G_TYPE_STRING);

      signals[SIGNAL_SetActiveCandidatePair] =
      g_signal_new ("set-active-candidate-pair",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_STRING,
                    G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);

      signals[SIGNAL_SetRemoteCandidateList] =
      g_signal_new ("set-remote-candidate-list",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INVALID)))), G_TYPE_INVALID)))));

      signals[SIGNAL_SetRemoteCodecs] =
      g_signal_new ("set-remote-codecs",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))));

      signals[SIGNAL_SetStreamPlaying] =
      g_signal_new ("set-stream-playing",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOOLEAN,
                    G_TYPE_NONE, 1, G_TYPE_BOOLEAN);

      signals[SIGNAL_SetStreamSending] =
      g_signal_new ("set-stream-sending",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOOLEAN,
                    G_TYPE_NONE, 1, G_TYPE_BOOLEAN);

      signals[SIGNAL_StartTelephonyEvent] =
      g_signal_new ("start-telephony-event",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__UCHAR,
                    G_TYPE_NONE, 1, G_TYPE_UCHAR);

      signals[SIGNAL_StopTelephonyEvent] =
      g_signal_new ("stop-telephony-event",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__VOID,
                    G_TYPE_NONE, 0);

      dbus_g_object_type_install_info (tp_svc_media_stream_handler_get_type (), &dbus_glib_tp_svc_media_stream_handler_object_info);
    }
}

GType
tp_svc_media_stream_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcMediaStreamHandlerClass),
      tp_svc_media_stream_handler_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcMediaStreamHandler", &info, 0);
  }

  return type;
}


/**
 * tp_svc_media_stream_handler_codec_choice_impl
 * @self: The object implementing this interface
 * @codec_id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method CodecChoice
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_codec_choice (TpSvcMediaStreamHandler *self,
                                          guint codec_id,
                                          DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_codec_choice_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->codec_choice);
  if (impl)
    (impl) (self, codec_id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_codec_choice:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CodecChoice method
 *
 * Register an implementation for the CodecChoice method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_codec_choice (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_codec_choice_impl impl)
{
  klass->codec_choice = impl;
}


/**
 * tp_svc_media_stream_handler_error_impl
 * @self: The object implementing this interface
 * @errno: FIXME: document args in genginterface
 * @message: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Error
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_error (TpSvcMediaStreamHandler *self,
                                   guint errno,
                                   const gchar *message,
                                   DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_error_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->error);
  if (impl)
    (impl) (self, errno, message, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_error:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Error method
 *
 * Register an implementation for the Error method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_error (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_error_impl impl)
{
  klass->error = impl;
}


/**
 * tp_svc_media_stream_handler_native_candidates_prepared_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method NativeCandidatesPrepared
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_native_candidates_prepared (TpSvcMediaStreamHandler *self,
                                                        DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_native_candidates_prepared_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->native_candidates_prepared);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_native_candidates_prepared:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the NativeCandidatesPrepared method
 *
 * Register an implementation for the NativeCandidatesPrepared method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_native_candidates_prepared (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_native_candidates_prepared_impl impl)
{
  klass->native_candidates_prepared = impl;
}


/**
 * tp_svc_media_stream_handler_new_active_candidate_pair_impl
 * @self: The object implementing this interface
 * @native_candidate_id: FIXME: document args in genginterface
 * @remote_candidate_id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method NewActiveCandidatePair
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_new_active_candidate_pair (TpSvcMediaStreamHandler *self,
                                                       const gchar *native_candidate_id,
                                                       const gchar *remote_candidate_id,
                                                       DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_new_active_candidate_pair_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->new_active_candidate_pair);
  if (impl)
    (impl) (self, native_candidate_id, remote_candidate_id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_new_active_candidate_pair:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the NewActiveCandidatePair method
 *
 * Register an implementation for the NewActiveCandidatePair method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_new_active_candidate_pair (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_new_active_candidate_pair_impl impl)
{
  klass->new_active_candidate_pair = impl;
}


/**
 * tp_svc_media_stream_handler_new_native_candidate_impl
 * @self: The object implementing this interface
 * @candidate_id: FIXME: document args in genginterface
 * @transports: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method NewNativeCandidate
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_new_native_candidate (TpSvcMediaStreamHandler *self,
                                                  const gchar *candidate_id,
                                                  const GPtrArray *transports,
                                                  DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_new_native_candidate_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->new_native_candidate);
  if (impl)
    (impl) (self, candidate_id, transports, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_new_native_candidate:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the NewNativeCandidate method
 *
 * Register an implementation for the NewNativeCandidate method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_new_native_candidate (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_new_native_candidate_impl impl)
{
  klass->new_native_candidate = impl;
}


/**
 * tp_svc_media_stream_handler_ready_impl
 * @self: The object implementing this interface
 * @codecs: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method Ready
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_ready (TpSvcMediaStreamHandler *self,
                                   const GPtrArray *codecs,
                                   DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_ready_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->ready);
  if (impl)
    (impl) (self, codecs, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_ready:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Ready method
 *
 * Register an implementation for the Ready method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_ready (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_ready_impl impl)
{
  klass->ready = impl;
}


/**
 * tp_svc_media_stream_handler_set_local_codecs_impl
 * @self: The object implementing this interface
 * @codecs: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetLocalCodecs
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_set_local_codecs (TpSvcMediaStreamHandler *self,
                                              const GPtrArray *codecs,
                                              DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_set_local_codecs_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->set_local_codecs);
  if (impl)
    (impl) (self, codecs, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_set_local_codecs:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetLocalCodecs method
 *
 * Register an implementation for the SetLocalCodecs method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_set_local_codecs (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_set_local_codecs_impl impl)
{
  klass->set_local_codecs = impl;
}


/**
 * tp_svc_media_stream_handler_stream_state_impl
 * @self: The object implementing this interface
 * @state: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method StreamState
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_stream_state (TpSvcMediaStreamHandler *self,
                                          guint state,
                                          DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_stream_state_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->stream_state);
  if (impl)
    (impl) (self, state, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_stream_state:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the StreamState method
 *
 * Register an implementation for the StreamState method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_stream_state (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_stream_state_impl impl)
{
  klass->stream_state = impl;
}


/**
 * tp_svc_media_stream_handler_supported_codecs_impl
 * @self: The object implementing this interface
 * @codecs: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SupportedCodecs
 * on interface org.freedesktop.Telepathy.Media.StreamHandler
 */
static void
tp_svc_media_stream_handler_supported_codecs (TpSvcMediaStreamHandler *self,
                                              const GPtrArray *codecs,
                                              DBusGMethodInvocation *context)
{
  tp_svc_media_stream_handler_supported_codecs_impl impl = (TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS (self)->supported_codecs);
  if (impl)
    (impl) (self, codecs, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_media_stream_handler_implement_supported_codecs:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SupportedCodecs method
 *
 * Register an implementation for the SupportedCodecs method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_media_stream_handler_implement_supported_codecs (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_supported_codecs_impl impl)
{
  klass->supported_codecs = impl;
}

/**
 * tp_svc_media_stream_handler_emit_add_remote_candidate:
 * @instance: An object implementing this interface
 * @candidate_id: FIXME: document args in genginterface
 * @transports: FIXME: document args in genginterface
 *
 * Emit the AddRemoteCandidate D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_add_remote_candidate (gpointer instance,
    const gchar * candidate_id,
    const GPtrArray * transports)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_AddRemoteCandidate], 0, candidate_id, transports);
}

/**
 * tp_svc_media_stream_handler_emit_close:
 * @instance: An object implementing this interface
 *
 * Emit the Close D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_close (gpointer instance)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_Close], 0);
}

/**
 * tp_svc_media_stream_handler_emit_remove_remote_candidate:
 * @instance: An object implementing this interface
 * @candidate_id: FIXME: document args in genginterface
 *
 * Emit the RemoveRemoteCandidate D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_remove_remote_candidate (gpointer instance,
    const gchar * candidate_id)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_RemoveRemoteCandidate], 0, candidate_id);
}

/**
 * tp_svc_media_stream_handler_emit_set_active_candidate_pair:
 * @instance: An object implementing this interface
 * @native_candidate_id: FIXME: document args in genginterface
 * @remote_candidate_id: FIXME: document args in genginterface
 *
 * Emit the SetActiveCandidatePair D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_set_active_candidate_pair (gpointer instance,
    const gchar * native_candidate_id,
    const gchar * remote_candidate_id)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_SetActiveCandidatePair], 0, native_candidate_id, remote_candidate_id);
}

/**
 * tp_svc_media_stream_handler_emit_set_remote_candidate_list:
 * @instance: An object implementing this interface
 * @remote_candidates: FIXME: document args in genginterface
 *
 * Emit the SetRemoteCandidateList D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_set_remote_candidate_list (gpointer instance,
    const GPtrArray * remote_candidates)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_SetRemoteCandidateList], 0, remote_candidates);
}

/**
 * tp_svc_media_stream_handler_emit_set_remote_codecs:
 * @instance: An object implementing this interface
 * @codecs: FIXME: document args in genginterface
 *
 * Emit the SetRemoteCodecs D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_set_remote_codecs (gpointer instance,
    const GPtrArray * codecs)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_SetRemoteCodecs], 0, codecs);
}

/**
 * tp_svc_media_stream_handler_emit_set_stream_playing:
 * @instance: An object implementing this interface
 * @playing: FIXME: document args in genginterface
 *
 * Emit the SetStreamPlaying D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_set_stream_playing (gpointer instance,
    const gboolean  playing)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_SetStreamPlaying], 0, playing);
}

/**
 * tp_svc_media_stream_handler_emit_set_stream_sending:
 * @instance: An object implementing this interface
 * @sending: FIXME: document args in genginterface
 *
 * Emit the SetStreamSending D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_set_stream_sending (gpointer instance,
    const gboolean  sending)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_SetStreamSending], 0, sending);
}

/**
 * tp_svc_media_stream_handler_emit_start_telephony_event:
 * @instance: An object implementing this interface
 * @event: FIXME: document args in genginterface
 *
 * Emit the StartTelephonyEvent D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_start_telephony_event (gpointer instance,
    const guchar  event)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_StartTelephonyEvent], 0, event);
}

/**
 * tp_svc_media_stream_handler_emit_stop_telephony_event:
 * @instance: An object implementing this interface
 *
 * Emit the StopTelephonyEvent D-Bus signal from @instance with the given arguments.
 */
void tp_svc_media_stream_handler_emit_stop_telephony_event (gpointer instance)
{
  g_assert (TP_IS_SVC_MEDIA_STREAM_HANDLER (instance));
  g_signal_emit (instance, signals[SIGNAL_StopTelephonyEvent], 0);
}

#include "_gen/svc-Media_Stream_Handler-glue.h"

