/*
 * _gen/svc-Properties_Interface.c - Source for TpSvcPropertiesInterface
 *
 *  Copyright (C) 2005-2007 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Properties_Interface.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_tp_svc_properties_interface_object_info;
struct _TpSvcPropertiesInterfaceClass {
    GObjectClass parent_class;
    tp_svc_properties_interface_get_properties_impl get_properties;
    tp_svc_properties_interface_list_properties_impl list_properties;
    tp_svc_properties_interface_set_properties_impl set_properties;
};

enum {
    SIGNAL_PropertiesChanged,
    SIGNAL_PropertyFlagsChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_properties_interface_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_PropertiesChanged] =
      g_signal_new ("properties-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_VALUE, G_TYPE_INVALID)))));

      signals[SIGNAL_PropertyFlagsChanged] =
      g_signal_new ("property-flags-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__BOXED,
                    G_TYPE_NONE, 1, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)))));

      dbus_g_object_type_install_info (tp_svc_properties_interface_get_type (), &dbus_glib_tp_svc_properties_interface_object_info);
    }
}

GType
tp_svc_properties_interface_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcPropertiesInterfaceClass),
      tp_svc_properties_interface_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcPropertiesInterface", &info, 0);
  }

  return type;
}


/**
 * tp_svc_properties_interface_get_properties_impl
 * @self: The object implementing this interface
 * @properties: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetProperties
 * on interface org.freedesktop.Telepathy.Properties
 */
static void
tp_svc_properties_interface_get_properties (TpSvcPropertiesInterface *self,
                                            const GArray *properties,
                                            DBusGMethodInvocation *context)
{
  tp_svc_properties_interface_get_properties_impl impl = (TP_SVC_PROPERTIES_INTERFACE_GET_CLASS (self)->get_properties);
  if (impl)
    (impl) (self, properties, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_properties_interface_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties method
 *
 * Register an implementation for the GetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_properties_interface_implement_get_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_get_properties_impl impl)
{
  klass->get_properties = impl;
}


/**
 * tp_svc_properties_interface_list_properties_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListProperties
 * on interface org.freedesktop.Telepathy.Properties
 */
static void
tp_svc_properties_interface_list_properties (TpSvcPropertiesInterface *self,
                                             DBusGMethodInvocation *context)
{
  tp_svc_properties_interface_list_properties_impl impl = (TP_SVC_PROPERTIES_INTERFACE_GET_CLASS (self)->list_properties);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_properties_interface_implement_list_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListProperties method
 *
 * Register an implementation for the ListProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_properties_interface_implement_list_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_list_properties_impl impl)
{
  klass->list_properties = impl;
}


/**
 * tp_svc_properties_interface_set_properties_impl
 * @self: The object implementing this interface
 * @properties: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetProperties
 * on interface org.freedesktop.Telepathy.Properties
 */
static void
tp_svc_properties_interface_set_properties (TpSvcPropertiesInterface *self,
                                            const GPtrArray *properties,
                                            DBusGMethodInvocation *context)
{
  tp_svc_properties_interface_set_properties_impl impl = (TP_SVC_PROPERTIES_INTERFACE_GET_CLASS (self)->set_properties);
  if (impl)
    (impl) (self, properties, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * tp_svc_properties_interface_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties method
 *
 * Register an implementation for the SetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
tp_svc_properties_interface_implement_set_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * tp_svc_properties_interface_emit_properties_changed:
 * @instance: An object implementing this interface
 * @properties: FIXME: document args in genginterface
 *
 * Emit the PropertiesChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_properties_interface_emit_properties_changed (gpointer instance,
    const GPtrArray * properties)
{
  g_assert (TP_IS_SVC_PROPERTIES_INTERFACE (instance));
  g_signal_emit (instance, signals[SIGNAL_PropertiesChanged], 0, properties);
}

/**
 * tp_svc_properties_interface_emit_property_flags_changed:
 * @instance: An object implementing this interface
 * @properties: FIXME: document args in genginterface
 *
 * Emit the PropertyFlagsChanged D-Bus signal from @instance with the given arguments.
 */
void tp_svc_properties_interface_emit_property_flags_changed (gpointer instance,
    const GPtrArray * properties)
{
  g_assert (TP_IS_SVC_PROPERTIES_INTERFACE (instance));
  g_signal_emit (instance, signals[SIGNAL_PropertyFlagsChanged], 0, properties);
}

#include "_gen/svc-Properties_Interface-glue.h"

